#include "format.hpp"
#include "panic.hpp"
#include "print.hpp"
#include "ranges/first.hpp"
#include "ranges/generated.hpp"
#include "tagged_union.hpp"
#include <cstdlib>
#include <iostream>
#include <stdio.h>

#define UTIL_ASSERT_FORMAT
#include "assert.hpp"
#include "ranges/collect.hpp"
#include <ranges>
#include <set>
#include <vector>
#include <string_view>

using namespace std::string_view_literals;

int main(int argc, const char *argv[]) {
  printf("Hello, Alloy!\n");
  auto vec = std::vector<int>({1, 2, 3, 4, 5});

  auto range = vec | std::views::filter([](auto &i) { return i % 2; });
  auto infinite_range = util::views::from([] {return 1;}) | std::views::take(5);

  auto random = util::views::from([] {
          return "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXY"
              [std::rand() %
               std::strlen(
                   "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXY")];
        }) |
        std::views::take(10) | util::views::collect<std::string>;

auto first = random | util::views::first;

util::println("{}", first);
util::println("{}", random);

  for (auto&& i : infinite_range) {
    util::print("{}\n", i);
  }

util::print("hello {}\n", "world");

  util::assert_eq("asdf"sv, "nsdf"sv);

  const auto set = util::collect<std::set<int>>(range);
  util::panic("asdf {}", 42);
  return 1;
}